/* (C) 2001-2002 Andrew J. Kroll */
/* see file README for license details */
/* socket.h */

#ifndef SOCKET_H_SEEN
#define SOCKET_H_SEEN

#ifndef CONFIG_H_SEEN
#include "config.h"
#endif

#include "in.h"

extern void check_sockets K__P F__P(void)P__F;
extern void schedulestuff K__P F__P(void)P__F;
#define CHECKSOKS check_sockets();
#define MAKEMEBLEED schedulestuff();
/* socket types */
#define SOCK_STREAM 1
#define SOCK_DGRAM 2
#define SOCK_RAW 3
#define SOCK_RDM 4
#define SOCK_SEQPACKET 5
#define SOCK_PACKET 10

#define SOKDAT 32 /* 27 + some padding to align it, also allows for future flags */

#define SOKALLOW BUFFERS

typedef size_t socklen_t; 

struct sockaddr {
	unsigned short	sa_family;	/* address family, AF_xxx	*/
	char 	sa_data[14];	/* 14 bytes of protocol address	*/
};

#define __SOCK_SIZE__   16              /* sizeof(struct sockaddr)	*/

struct sockaddr_in {
	unsigned short	sin_family;	/* Address family		*/
	unsigned short	sin_port;	/* Port number			*/ 
	struct in_addr	sin_addr;	/* Internet address		*/
	unsigned char	__pad[__SOCK_SIZE__ - sizeof(short int) - sizeof(unsigned short int) - sizeof(struct in_addr)];
};

extern void sendsocket K__P F__P(int)P__F;
extern int socket K__P F__P(int, int, int)P__F;
extern int sockwrite K__P F__P(int, void *, unsigned int)P__F;
extern int sockread K__P F__P(int, void *, unsigned int)P__F;
extern int sockclose K__P F__P(int)P__F;
extern int sockconnect K__P F__P(int, unsigned int, unsigned char *)P__F;
extern int connect K__P F__P(int, struct sockaddr_in *, int)P__F;
extern int bind K__P F__P(int, struct sockaddr_in *, int)P__F;
extern int listen K__P F__P(int, int)P__F;
extern int sockstatus K__P F__P(int)P__F;
extern int bindcount K__P F__P(int)P__F;
extern int acceptready K__P F__P(int)P__F;
extern int accept K__P F__P(int, struct sockaddr_in *, int *)P__F;
#if UDP_ENABLED
extern int sendto K__P F__P(int, const void *, size_t, unsigned int, const struct sockaddr *, socklen_t *)P__F;
extern int recvfrom K__P F__P(int, void *, size_t, unsigned int, struct sockaddr *, socklen_t *)P__F;


#endif /* UDP_ENABLED */


#endif /* SOCKET_H_SEEN */
