/* (C) 2001-2002 Andrew J. Kroll */
/*   see file README for license details */
/*

UDP RFC 0768
Portions sponsored by Building 31 Clustering AB, Sweden.

Pre-optimized for the compiler via
keeping 0x00 stores together and other tricks to help the C optimizer
I know this makes it harder to follow, but it's worth it! HONEST!

*/

#include <stdlib.h> 
#include <stdio.h>
#include <string.h>
#include "tcpvars.h"
#include "in.h"
#include "netinet.h"
#include "socket.h"
#include "ioconfig.h"
#include "chcksum.h"
#include "timers.h"
#include "tcpx.h"
#include "udpx.h"
#include "compat.h"
#include "ip.h"


#ifdef UDP_ENABLED
#define DEBUGU 0

unsigned int createudp(buffer, ptr, datalen, pdata, sktp)
unsigned char *buffer;
unsigned char *ptr;
int datalen;
unsigned char *pdata;
unsigned char *sktp;
{
	unsigned int y = 8; /* length of minimum header in octets */
	unsigned int bar = (buffer[2] * 256) + buffer[3]; /* current pointer */


	/* src port */
	buffer[bar     ] = sktp[ 4];
	buffer[bar +  1] = sktp[ 5];
	/* dest port */
	buffer[bar +  2] = ptr[ 0];
	buffer[bar +  3] = ptr[ 1];
	/* checksum */
	buffer[bar +  6] = 0x00;
	buffer[bar +  7] = 0x00;
	
	/* attach data */
	memmove(buffer + bar + y, pdata, datalen);

	/* add to octet counts */
	y += datalen;
	/* length */
	buffer[bar +  4] = (y / 256) & 0xff;
	buffer[bar +  5] = y & 0xff;
	y += bar;
	buffer[2] = (y / 256) & 0xff;
	buffer[3] = y & 0xff;

	return(y);
}


void udpsumming(buffer)
unsigned char *buffer;
{
	unsigned int sum;
	unsigned int usum;
	unsigned int iplen;
	unsigned int udplen;
	unsigned int totallen;

	totallen = (buffer[2] * 256) + buffer[3];
	iplen = (buffer[0] & 0x0f) * 4;
	udplen = totallen - iplen;
	
	/* checksum ip */
	sum = checksum(NULL, 0, buffer, iplen);

	/* checksum udp */
	usum = checksum(buffer, 12, &buffer[iplen], udplen);
	if(usum == 0x0000) usum=0xffff;

	buffer[10] = (sum / 256) & 0xff;
	buffer[11] = sum & 0xff;
	buffer[iplen + 6] = (usum / 256) & 0xff;
	buffer[iplen + 7] = usum & 0xff;
}

#else
void udpxnotused(VOIDFIX)
{
	return(0);
}
#endif /* UDP_ENABLED */

/* tell link parser who we are and where we belong

02FF libznet.lib udpx.obj xxLIBRARYxx

*/

